diff -rupN epgsearch-0.9.25.beta18/menu_commands.c epgsearch-0.9.25.beta18-1/menu_commands.c
--- epgsearch-0.9.25.beta18/menu_commands.c	2010-09-19 20:01:58.000000000 +0200
+++ epgsearch-0.9.25.beta18-1/menu_commands.c	2011-01-08 22:42:28.000000000 +0100
@@ -165,7 +165,7 @@ eOSState cMenuSearchCommands::Record(voi
       }
 #ifdef USE_PINPLUGIN
       aux = "";
-      aux = UpdateAuxValue(aux, "protected", timer->FskProtection() ? "yes" : "no");
+      aux = UpdateAuxValue(aux, "protected", timer->HasFlags(tfProtected) ? "yes" : "no");
       fullaux = UpdateAuxValue(fullaux, "pin-plugin", aux);
 #endif
 
diff -rupN epgsearch-0.9.25.beta18/menu_main.c epgsearch-0.9.25.beta18-1/menu_main.c
--- epgsearch-0.9.25.beta18/menu_main.c	2010-09-19 20:01:58.000000000 +0200
+++ epgsearch-0.9.25.beta18-1/menu_main.c	2011-01-08 22:42:46.000000000 +0100
@@ -226,7 +226,7 @@ eOSState cMenuSearchMain::Record(void)
 	 }
 #ifdef USE_PINPLUGIN
       aux = "";
-      aux = UpdateAuxValue(aux, "protected", timer->FskProtection() ? "yes" : "no");
+      aux = UpdateAuxValue(aux, "protected", timer->HasFlags(tfProtected) ? "yes" : "no");
       fullaux = UpdateAuxValue(fullaux, "pin-plugin", aux);
 #endif
 
diff -rupN epgsearch-0.9.25.beta18/menu_myedittimer.c epgsearch-0.9.25.beta18-1/menu_myedittimer.c
--- epgsearch-0.9.25.beta18/menu_myedittimer.c	2010-09-19 20:01:57.000000000 +0200
+++ epgsearch-0.9.25.beta18-1/menu_myedittimer.c	2011-01-09 00:51:27.000000000 +0100
@@ -34,6 +34,10 @@ The project's page is at http://winni.vd
 #include "menu_deftimercheckmethod.h"
 #include "timerstatus.h"
 #include <math.h>
+#ifdef USE_PINPLUGIN
+#include <vdr/childlock.h>
+using namespace PinPatch;
+#endif
 
 const char *cMenuMyEditTimer::CheckModes[3];
 
@@ -63,7 +67,7 @@ cMenuMyEditTimer::cMenuMyEditTimer(cTime
 	strcpy(file, Timer->File());
 	channel = Timer->Channel()->Number();
 #ifdef USE_PINPLUGIN
-    fskProtection = Timer->FskProtection();  
+    fskProtection = Timer->HasFlags(tfProtected);  
 #endif
 	if (forcechannel)
 	    channel = forcechannel->Number();
@@ -125,7 +129,7 @@ void cMenuMyEditTimer::Set()
     Add(new cMenuEditStrItem( tr("Directory"), directory, MaxFileName, tr(AllowedChars)));
     Add(new cMenuEditBitItem( trVDR("Active"),       &flags, tfActive));
 #ifdef USE_PINPLUGIN
-    if (cOsd::pinValid) Add(new cMenuEditChanItem(tr("Channel"), &channel));
+    if (ChildLock::IsUnlocked()) Add(new cMenuEditChanItem(tr("Channel"), &channel));
     else {
       cString buf = cString::sprintf("%s\t%s", tr("Channel"), Channels.GetByNumber(channel)->Name());
       Add(new cOsdItem(buf));
@@ -144,7 +148,7 @@ void cMenuMyEditTimer::Set()
     Add(new cMenuEditIntItem( trVDR("Priority"),     &priority, 0, MAXPRIORITY));
     Add(new cMenuEditIntItem( trVDR("Lifetime"),     &lifetime, 0, MAXLIFETIME));
 #ifdef USE_PINPLUGIN
-    if (cOsd::pinValid || !fskProtection) Add(new cMenuEditBoolItem(tr("Childlock"),&fskProtection));
+    if (ChildLock::IsUnlocked() || !fskProtection) Add(new cMenuEditBoolItem(tr("Childlock"),&fskProtection));
     else {
       cString buf = cString::sprintf("%s\t%s", tr("Childlock"), fskProtection ? trVDR("yes") : trVDR("no"));
       Add(new cOsdItem(buf));
diff -rupN epgsearch-0.9.25.beta18/menu_searchresults.c epgsearch-0.9.25.beta18-1/menu_searchresults.c
--- epgsearch-0.9.25.beta18/menu_searchresults.c	2010-09-19 20:01:56.000000000 +0200
+++ epgsearch-0.9.25.beta18-1/menu_searchresults.c	2011-01-08 22:44:10.000000000 +0100
@@ -259,7 +259,7 @@ eOSState cMenuSearchResults::Record(void
 
 #ifdef USE_PINPLUGIN
          aux = "";
-         aux = UpdateAuxValue(aux, "protected", timer->FskProtection() ? "yes" : "no");
+         aux = UpdateAuxValue(aux, "protected", timer->HasFlags(tfProtected) ? "yes" : "no");
          fullaux = UpdateAuxValue(fullaux, "pin-plugin", aux);
 #endif
 
diff -rupN epgsearch-0.9.25.beta18/menu_whatson.c epgsearch-0.9.25.beta18-1/menu_whatson.c
--- epgsearch-0.9.25.beta18/menu_whatson.c	2010-11-24 19:14:00.000000000 +0100
+++ epgsearch-0.9.25.beta18-1/menu_whatson.c	2011-01-08 22:44:01.000000000 +0100
@@ -580,7 +580,7 @@ eOSState cMenuWhatsOnSearch::Record(void
          }
 #ifdef USE_PINPLUGIN
          aux = "";
-         aux = UpdateAuxValue(aux, "protected", timer->FskProtection() ? "yes" : "no");
+         aux = UpdateAuxValue(aux, "protected", timer->HasFlags(tfProtected) ? "yes" : "no");
          fullaux = UpdateAuxValue(fullaux, "pin-plugin", aux);
 #endif
          SetAux(timer, fullaux);