--- fontosd-iso8859-2.c.org	Sat Dec 18 17:14:50 2004
+++ fontosd-iso8859-2.c	Thu Nov 24 09:55:09 2005
@@ -3948,23 +3948,23 @@
      0x00000000,  // .............
      0x00000000,  // .............
      0x00000000,  // .............
-     0x000001F0,  // ....*****....
-     0x000003F8,  // ...*******...
-     0x0000071C,  // ..***...***..
-     0x00000C0C,  // .**......**..
-     0x00000C06,  // .**.......**.
-     0x00000C06,  // .**.......**.
-     0x00000E00,  // .***.........
-     0x00000700,  // ..***........
+     0x00000600,  // ..**.........
+     0x00000600,  // ..**.........
+     0x00000600,  // ..**.........
+     0x00000600,  // ..**.........
+     0x00000600,  // ..**.........
+     0x00000600,  // ..**.........
+     0x00000600,  // ..**.........
+     0x00000600,  // ..**.........
+     0x00000FE0,  // .*******.....
      0x00000FE0,  // .*******.....
-     0x00000FA0,  // .*****.*.....
-     0x00000380,  // ...***.......
-     0x00000180,  // ....**.......
-     0x00000180,  // ....**.......
-     0x00000300,  // ...**........
      0x00000600,  // ..**.........
-     0x00000FFE,  // .***********.
-     0x00000FFC,  // .**********..
+     0x00000600,  // ..**.........
+     0x00000600,  // ..**.........
+     0x00000600,  // ..**.........
+     0x00000600,  // ..**.........
+     0x000007FE,  // ..**********.
+     0x000007FE,  // ..**********.
      0x00000000,  // .............
      0x00000000,  // .............
      0x00000000,  // .............
@@ -4032,34 +4032,34 @@
      0x00000000,  // .............
   },
   {             // 166
-     6, 27,
-     0x00000000,  // ......
-     0x00000000,  // ......
-     0x00000000,  // ......
-     0x00000000,  // ......
-     0x00000000,  // ......
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x00000000,  // ......
-     0x00000000,  // ......
-     0x00000000,  // ......
-     0x00000000,  // ......
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
-     0x0000000C,  // ..**..
+     15, 27,
+     0x00000070,  // ........***....
+     0x000000E0,  // .......***.....
+     0x000001C0,  // ......***......
+     0x00000380,  // .....***.......
+     0x00000000,  // ...............
+     0x000003E0,  // .....*****.....
+     0x00000FF8,  // ...*********...
+     0x00000C1C,  // ...**.....***..
+     0x0000180C,  // ..**.......**..
+     0x00001804,  // ..**........*..
+     0x00001800,  // ..**...........
+     0x00001C00,  // ..***..........
+     0x00000F80,  // ...*****.......
+     0x000007F8,  // ....********...
+     0x0000007C,  // ........*****..
+     0x0000000E,  // ...........***.
+     0x00000006,  // ............**.
+     0x00003006,  // .**.........**.
+     0x00001806,  // ..**........**.
+     0x0000180C,  // ..**.......**..
+     0x00000FF8,  // ...*********...
+     0x000007F0,  // ....*******....
+     0x00000000,  // ...............
+     0x00000000,  // ...............
+     0x00000000,  // ...............
+     0x00000000,  // ...............
+     0x00000000,  // ...............
   },
   {             // 167
      13, 27,
@@ -4212,34 +4212,34 @@
      0x00000000,  // ..............
   },
   {             // 172
-     13, 27,
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000FFF,  // .************
-     0x00000FFF,  // .************
-     0x00000003,  // ...........**
-     0x00000003,  // ...........**
-     0x00000003,  // ...........**
-     0x00000003,  // ...........**
-     0x00000003,  // ...........**
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
+     14, 27,
+     0x00000000,  // ..............
+     0x00000030,  // ........**....
+     0x00000060,  // .......**.....
+     0x000000C0,  // ......**......
+     0x00000000,  // ..............
+     0x00001FFE,  // .************.
+     0x00001FFE,  // .************.
+     0x0000000E,  // ..........***.
+     0x0000000C,  // ..........**..
+     0x0000001C,  // .........***..
+     0x00000038,  // ........***...
+     0x00000070,  // .......***....
+     0x000000E0,  // ......***.....
+     0x000000C0,  // ......**......
+     0x000001C0,  // .....***......
+     0x00000380,  // ....***.......
+     0x00000700,  // ...***........
+     0x00000600,  // ...**.........
+     0x00000E00,  // ..***.........
+     0x00001C00,  // .***..........
+     0x00001FFE,  // .************.
+     0x00001FFE,  // .************.
+     0x00000000,  // ..............
+     0x00000000,  // ..............
+     0x00000000,  // ..............
+     0x00000000,  // ..............
+     0x00000000,  // ..............
   },
   {             // 173
      8, 27,
@@ -4302,34 +4302,34 @@
      0x00000000,  // ..............
   },
   {             // 175
-     8, 27,
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x0000007E,  // .******.
-     0x0000007E,  // .******.
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
+     14, 27,
+     0x00000000,  // ..............
+     0x00000000,  // ..............
+     0x000000C0,  // ......**......
+     0x000000C0,  // ......**......
+     0x00000000,  // ..............
+     0x00001FFE,  // .************.
+     0x00001FFE,  // .************.
+     0x0000000E,  // ..........***.
+     0x0000000C,  // ..........**..
+     0x0000001C,  // .........***..
+     0x00000038,  // ........***...
+     0x00000070,  // .......***....
+     0x000000E0,  // ......***.....
+     0x000000C0,  // ......**......
+     0x000001C0,  // .....***......
+     0x00000380,  // ....***.......
+     0x00000700,  // ...***........
+     0x00000600,  // ...**.........
+     0x00000E00,  // ..***.........
+     0x00001C00,  // .***..........
+     0x00001FFE,  // .************.
+     0x00001FFE,  // .************.
+     0x00000000,  // ..............
+     0x00000000,  // ..............
+     0x00000000,  // ..............
+     0x00000000,  // ..............
+     0x00000000,  // ..............
   },
   {             // 176
      14, 27,
@@ -4371,23 +4371,23 @@
      0x00000000,  // .............
      0x00000000,  // .............
      0x00000000,  // .............
-     0x00000060,  // ......**.....
-     0x00000060,  // ......**.....
-     0x00000060,  // ......**.....
-     0x00000060,  // ......**.....
-     0x00000FFE,  // .***********.
-     0x00000FFE,  // .***********.
-     0x00000060,  // ......**.....
-     0x00000060,  // ......**.....
-     0x00000060,  // ......**.....
-     0x00000060,  // ......**.....
-     0x00000060,  // ......**.....
-     0x00000000,  // .............
-     0x00000FFE,  // .***********.
-     0x00000FFE,  // .***********.
-     0x00000000,  // .............
      0x00000000,  // .............
      0x00000000,  // .............
+     0x000001F0,  // ....*****....
+     0x000007FC,  // ..*********..
+     0x0000060C,  // ..**.....**..
+     0x0000040C,  // ..*......**..
+     0x0000000C,  // .........**..
+     0x000001FC,  // ....*******..
+     0x000007CC,  // ..*****..**..
+     0x00000E0C,  // .***.....**..
+     0x00000C0C,  // .**......**..
+     0x00000C1C,  // .**.....***..
+     0x00000FFE,  // .***********.
+     0x000003EE,  // ...*****.***.
+     0x0000000E,  // .........***.
+     0x0000000E,  // .........***.
+     0x00000006,  // ..........**.
      0x00000000,  // .............
      0x00000000,  // .............
   },
@@ -4428,23 +4428,23 @@
      0x00000000,  // ........
      0x00000000,  // ........
      0x00000000,  // ........
-     0x00000000,  // ........
-     0x0000003C,  // ..****..
-     0x0000007E,  // .******.
-     0x00000046,  // .*...**.
-     0x00000006,  // .....**.
-     0x0000001C,  // ...***..
-     0x00000006,  // .....**.
-     0x00000003,  // ......**
-     0x000000C3,  // **....**
-     0x0000007E,  // .******.
+     0x00000030,  // ..**....
+     0x00000030,  // ..**....
+     0x00000030,  // ..**....
+     0x00000030,  // ..**....
+     0x00000030,  // ..**....
+     0x00000030,  // ..**....
+     0x0000001E,  // ...****.
      0x0000003C,  // ..****..
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
-     0x00000000,  // ........
+     0x00000070,  // .***....
+     0x00000030,  // ..**....
+     0x00000030,  // ..**....
+     0x00000030,  // ..**....
+     0x00000030,  // ..**....
+     0x00000030,  // ..**....
+     0x00000030,  // ..**....
+     0x00000030,  // ..**....
+     0x00000030,  // ..**....
      0x00000000,  // ........
      0x00000000,  // ........
      0x00000000,  // ........
@@ -4518,27 +4518,27 @@
      0x00000000,  // ............
      0x00000000,  // ............
      0x00000000,  // ............
-     0x000000FF,  // ....********
-     0x000001FF,  // ...*********
-     0x000003F6,  // ..******.**.
-     0x000003F6,  // ..******.**.
-     0x000007F6,  // .*******.**.
-     0x000007F6,  // .*******.**.
-     0x000007F6,  // .*******.**.
-     0x000007F6,  // .*******.**.
-     0x000003F6,  // ..******.**.
-     0x000003F6,  // ..******.**.
-     0x000000F6,  // ....****.**.
-     0x00000036,  // ......**.**.
-     0x00000036,  // ......**.**.
-     0x00000036,  // ......**.**.
-     0x00000036,  // ......**.**.
-     0x00000036,  // ......**.**.
-     0x00000036,  // ......**.**.
-     0x00000036,  // ......**.**.
-     0x00000036,  // ......**.**.
-     0x00000036,  // ......**.**.
-     0x00000036,  // ......**.**.
+     0x00000030,  // ......**....
+     0x00000060,  // .....**.....
+     0x000000C0,  // ....**......
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x000001F8,  // ...******...
+     0x000003FC,  // ..********..
+     0x0000060C,  // .**.....**..
+     0x00000600,  // .**.........
+     0x00000700,  // .***........
+     0x000003F0,  // ..******....
+     0x000000FC,  // ....******..
+     0x0000000E,  // ........***.
+     0x00000606,  // .**......**.
+     0x00000606,  // .**......**.
+     0x000007FC,  // .*********..
+     0x000001F8,  // ...******...
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
      0x00000000,  // ............
   },
   {             // 183
@@ -4692,34 +4692,34 @@
      0x00000000,  // .......
   },
   {             // 188
-     20, 27,
-     0x00000000,  // ....................
-     0x00000000,  // ....................
-     0x00000000,  // ....................
-     0x00000000,  // ....................
-     0x00000000,  // ....................
-     0x00000000,  // ....................
-     0x00018030,  // ...**.........**....
-     0x00038020,  // ..***.........*.....
-     0x00078040,  // .****........*......
-     0x000180C0,  // ...**.......**......
-     0x00018180,  // ...**......**.......
-     0x00018100,  // ...**......*........
-     0x0001830C,  // ...**.....**....**..
-     0x0001860C,  // ...**....**.....**..
-     0x0001861C,  // ...**....**....***..
-     0x00000C3C,  // ........**....****..
-     0x0000186C,  // .......**....**.**..
-     0x0000384C,  // ......***....*..**..
-     0x000030FF,  // ......**....********
-     0x000060FF,  // .....**.....********
-     0x0000E00C,  // ....***.........**..
-     0x0000C004,  // ....**...........*..
-     0x00000000,  // ....................
-     0x00000000,  // ....................
-     0x00000000,  // ....................
-     0x00000000,  // ....................
-     0x00000000,  // ....................
+     12, 27,
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000030,  // ......**....
+     0x00000060,  // .....**.....
+     0x000000C0,  // ....**......
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x000007FC,  // .*********..
+     0x000007FC,  // .*********..
+     0x00000018,  // .......**...
+     0x00000018,  // .......**...
+     0x00000030,  // ......**....
+     0x00000060,  // .....**.....
+     0x000000C0,  // ....**......
+     0x00000180,  // ...**.......
+     0x00000300,  // ..**........
+     0x00000600,  // .**.........
+     0x000007FE,  // .**********.
+     0x000007FE,  // .**********.
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
   },
   {             // 189
      20, 27,
@@ -4782,34 +4782,34 @@
      0x00000000,  // ............
   },
   {             // 191
-     14, 27,
-     0x00000000,  // ..............
-     0x00000000,  // ..............
-     0x00000000,  // ..............
-     0x00000000,  // ..............
-     0x00000000,  // ..............
-     0x00000000,  // ..............
-     0x00000000,  // ..............
-     0x00000000,  // ..............
-     0x00000000,  // ..............
-     0x00000000,  // ..............
-     0x000000C0,  // ......**......
-     0x000000C0,  // ......**......
-     0x00000000,  // ..............
-     0x00000000,  // ..............
-     0x00000000,  // ..............
-     0x000000C0,  // ......**......
-     0x000000C0,  // ......**......
-     0x000001C0,  // .....***......
-     0x00000380,  // ....***.......
-     0x00000700,  // ...***........
-     0x00000600,  // ...**.........
-     0x00000C00,  // ..**..........
-     0x00000C0C,  // ..**......**..
-     0x00000C0C,  // ..**......**..
-     0x00000E1C,  // ..***....***..
-     0x000007F8,  // ...********...
-     0x000003E0,  // ....*****.....
+     12, 27,
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000060,  // .....**.....
+     0x00000060,  // .....**.....
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x000007FC,  // .*********..
+     0x000007FC,  // .*********..
+     0x00000018,  // .......**...
+     0x00000018,  // .......**...
+     0x00000030,  // ......**....
+     0x00000060,  // .....**.....
+     0x000000C0,  // ....**......
+     0x00000180,  // ...**.......
+     0x00000300,  // ..**........
+     0x00000600,  // .**.........
+     0x000007FE,  // .**********.
+     0x000007FE,  // .**********.
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
+     0x00000000,  // ............
   },
   {             // 192
      15, 27,
@@ -5113,10 +5113,10 @@
   },
   {             // 202
      15, 27,
-     0x000000C0,  // .......**......
-     0x000001E0,  // ......****.....
-     0x00000320,  // .....**..*.....
-     0x00000230,  // .....*...**....
+     0x00000000,  // ...............
+     0x00000000,  // ...............
+     0x00000000,  // ...............
+     0x00000000,  // ...............
      0x00000000,  // ...............
      0x00001FFE,  // ..************.
      0x00001FFE,  // ..************.
@@ -5135,9 +5135,9 @@
      0x00001800,  // ..**...........
      0x00001FFE,  // ..************.
      0x00001FFE,  // ..************.
-     0x00000000,  // ...............
-     0x00000000,  // ...............
-     0x00000000,  // ...............
+     0x00000006,  // ............**.
+     0x00000006,  // ............**.
+     0x00000006,  // ............**.
      0x00000000,  // ...............
      0x00000000,  // ...............
   },
@@ -5323,10 +5323,10 @@
   },
   {             // 209
      17, 27,
-     0x00000000,  // .................
-     0x00000760,  // ......***.**.....
-     0x00000FE0,  // .....*******.....
+     0x00000070,  // ..........***....
+     0x00000060,  // ..........**.....
      0x000000C0,  // .........**......
+     0x00000180,  // ........**.......
      0x00000000,  // .................
      0x0000600C,  // ..**.........**..
      0x0000700C,  // ..***........**..
@@ -6078,9 +6078,9 @@
      0x00000000,  // .............
      0x00000000,  // .............
      0x00000000,  // .............
-     0x000000E0,  // .....***.....
-     0x000000B0,  // .....*.**....
-     0x00000190,  // ....**..*....
+     0x00000000,  // .............
+     0x00000000,  // .............
+     0x00000000,  // .............
      0x00000000,  // .............
      0x00000000,  // .............
      0x000001F0,  // ....*****....
@@ -6095,9 +6095,9 @@
      0x0000060C,  // ..**.....**..
      0x000007F8,  // ..********...
      0x000001F0,  // ....*****....
-     0x00000000,  // .............
-     0x00000000,  // .............
-     0x00000000,  // .............
+     0x00000038,  // .......***...
+     0x00000070,  // ......***....
+     0x00000038,  // .......***...
      0x00000000,  // .............
      0x00000000,  // .............
   },
@@ -6288,9 +6288,9 @@
      0x00000000,  // .............
      0x00000000,  // .............
      0x00000000,  // .............
-     0x00000180,  // ....**.......
-     0x000003F8,  // ...*******...
-     0x00000270,  // ...*..***....
+     0x0000000C,  // .........**..
+     0x00000018,  // ........**...
+     0x00000030,  // .......**....
      0x00000000,  // .............
      0x00000000,  // .............
      0x000004F8,  // ..*..*****...


--- i18n.c.org	Sun Oct 30 14:37:57 2005
+++ i18n.c	Thu Nov 24 13:43:11 2005
@@ -112,7 +112,7 @@
     "iso8859-1",
     "iso8859-1",
     "iso8859-15",
-    "iso8859-1",
+    "iso8859-2",
     "iso8859-1",
     "iso8859-7",
     "iso8859-1",