>From 79a900a9995c1d401543e2804027cc019b5f7375 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Ville=20Skytt=C3=A4?= <ville.skytta@iki.fi>
Date: Sun, 17 Mar 2013 13:43:40 +0200
Subject: [PATCH 2/2] Rename PLGCFG to PLUGINCONFIG.

---
 Make.config.template             | 2 +-
 Makefile                         | 2 +-
 PLUGINS/src/dvbhddevice/Makefile | 4 ++--
 PLUGINS/src/dvbsddevice/Makefile | 4 ++--
 PLUGINS/src/epgtableid0/Makefile | 4 ++--
 PLUGINS/src/hello/Makefile       | 4 ++--
 PLUGINS/src/osddemo/Makefile     | 4 ++--
 PLUGINS/src/pictures/Makefile    | 4 ++--
 PLUGINS/src/rcu/Makefile         | 4 ++--
 PLUGINS/src/servicedemo/Makefile | 4 ++--
 PLUGINS/src/skincurses/Makefile  | 4 ++--
 PLUGINS/src/status/Makefile      | 4 ++--
 PLUGINS/src/svdrpdemo/Makefile   | 4 ++--
 newplugin                        | 4 ++--
 14 files changed, 26 insertions(+), 26 deletions(-)

diff --git a/Make.config.template b/Make.config.template
index 40cfefe..8a04fd7 100644
--- a/Make.config.template
+++ b/Make.config.template
@@ -62,7 +62,7 @@ endif
 
 # Use this if you want to have a central place where you configure compile time
 # parameters for plugins:
-#PLGCFG = $(CONFDIR)/plugins.mk
+#PLUGINCONFIG = $(CONFDIR)/plugins.mk
 
 ### The remote control:
 
diff --git a/Makefile b/Makefile
index 91506e2..a881b03 100644
--- a/Makefile
+++ b/Makefile
@@ -147,7 +147,7 @@ vdr.pc:
 	@echo "resdir=$(RESDIR)" >> $@
 	@echo "libdir=$(LIBDIR)" >> $@
 	@echo "locdir=$(LOCDIR)" >> $@
-	@echo "plgcfg=$(PLGCFG)" >> $@
+	@echo "plgcfg=$(PLUGINCONFIG)" >> $@
 	@echo "apiversion=$(APIVERSION)" >> $@
 	@echo "cflags=$(CFLAGS) $(CDEFINES) $(CINCLUDES) $(HDRDIR)" >> $@
 	@echo "cxxflags=$(CXXFLAGS) $(CDEFINES) $(CINCLUDES) $(HDRDIR)" >> $@
diff --git a/PLUGINS/src/dvbhddevice/Makefile b/PLUGINS/src/dvbhddevice/Makefile
index 0bfd136..c65e3b0 100644
--- a/PLUGINS/src/dvbhddevice/Makefile
+++ b/PLUGINS/src/dvbhddevice/Makefile
@@ -18,7 +18,7 @@ VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ pri
 PKGCFG = $(if $(VDRDIR),$(shell pkg-config --variable=$(1) $(VDRDIR)/vdr.pc),$(shell pkg-config --variable=$(1) vdr || pkg-config --variable=$(1) ../../../vdr.pc))
 LIBDIR = $(call PKGCFG,libdir)
 LOCDIR = $(call PKGCFG,locdir)
-PLGCFG = $(call PKGCFG,plgcfg)
+PLUGINCONFIG = $(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
 
@@ -33,7 +33,7 @@ APIVERSION = $(call PKGCFG,apiversion)
 
 ### Allow user defined options to overwrite defaults:
 
--include $(PLGCFG)
+-include $(PLUGINCONFIG)
 
 ### The name of the distribution archive:
 
diff --git a/PLUGINS/src/dvbsddevice/Makefile b/PLUGINS/src/dvbsddevice/Makefile
index f7e73b2..1bde961 100644
--- a/PLUGINS/src/dvbsddevice/Makefile
+++ b/PLUGINS/src/dvbsddevice/Makefile
@@ -18,7 +18,7 @@ VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ pri
 # Use package data if installed...otherwise assume we're under the VDR source directory:
 PKGCFG = $(if $(VDRDIR),$(shell pkg-config --variable=$(1) $(VDRDIR)/vdr.pc),$(shell pkg-config --variable=$(1) vdr || pkg-config --variable=$(1) ../../../vdr.pc))
 LIBDIR = $(call PKGCFG,libdir)
-PLGCFG = $(call PKGCFG,plgcfg)
+PLUGINCONFIG = $(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
 
@@ -33,7 +33,7 @@ APIVERSION = $(call PKGCFG,apiversion)
 
 ### Allow user defined options to overwrite defaults:
 
--include $(PLGCFG)
+-include $(PLUGINCONFIG)
 
 ### The name of the distribution archive:
 
diff --git a/PLUGINS/src/epgtableid0/Makefile b/PLUGINS/src/epgtableid0/Makefile
index 6190e62..72ca903 100644
--- a/PLUGINS/src/epgtableid0/Makefile
+++ b/PLUGINS/src/epgtableid0/Makefile
@@ -18,7 +18,7 @@ VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ pri
 # Use package data if installed...otherwise assume we're under the VDR source directory:
 PKGCFG = $(if $(VDRDIR),$(shell pkg-config --variable=$(1) $(VDRDIR)/vdr.pc),$(shell pkg-config --variable=$(1) vdr || pkg-config --variable=$(1) ../../../vdr.pc))
 LIBDIR = $(call PKGCFG,libdir)
-PLGCFG = $(call PKGCFG,plgcfg)
+PLUGINCONFIG = $(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
 
@@ -33,7 +33,7 @@ APIVERSION = $(call PKGCFG,apiversion)
 
 ### Allow user defined options to overwrite defaults:
 
--include $(PLGCFG)
+-include $(PLUGINCONFIG)
 
 ### The name of the distribution archive:
 
diff --git a/PLUGINS/src/hello/Makefile b/PLUGINS/src/hello/Makefile
index 4bdd5c9..9cec663 100644
--- a/PLUGINS/src/hello/Makefile
+++ b/PLUGINS/src/hello/Makefile
@@ -19,7 +19,7 @@ VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ pri
 PKGCFG = $(if $(VDRDIR),$(shell pkg-config --variable=$(1) $(VDRDIR)/vdr.pc),$(shell pkg-config --variable=$(1) vdr || pkg-config --variable=$(1) ../../../vdr.pc))
 LIBDIR = $(call PKGCFG,libdir)
 LOCDIR = $(call PKGCFG,locdir)
-PLGCFG = $(call PKGCFG,plgcfg)
+PLUGINCONFIG = $(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
 
@@ -34,7 +34,7 @@ APIVERSION = $(call PKGCFG,apiversion)
 
 ### Allow user defined options to overwrite defaults:
 
--include $(PLGCFG)
+-include $(PLUGINCONFIG)
 
 ### The name of the distribution archive:
 
diff --git a/PLUGINS/src/osddemo/Makefile b/PLUGINS/src/osddemo/Makefile
index 9b7e2c1..9d63bce 100644
--- a/PLUGINS/src/osddemo/Makefile
+++ b/PLUGINS/src/osddemo/Makefile
@@ -18,7 +18,7 @@ VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ pri
 # Use package data if installed...otherwise assume we're under the VDR source directory:
 PKGCFG = $(if $(VDRDIR),$(shell pkg-config --variable=$(1) $(VDRDIR)/vdr.pc),$(shell pkg-config --variable=$(1) vdr || pkg-config --variable=$(1) ../../../vdr.pc))
 LIBDIR = $(call PKGCFG,libdir)
-PLGCFG = $(call PKGCFG,plgcfg)
+PLUGINCONFIG = $(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
 
@@ -33,7 +33,7 @@ APIVERSION = $(call PKGCFG,apiversion)
 
 ### Allow user defined options to overwrite defaults:
 
--include $(PLGCFG)
+-include $(PLUGINCONFIG)
 
 ### The name of the distribution archive:
 
diff --git a/PLUGINS/src/pictures/Makefile b/PLUGINS/src/pictures/Makefile
index 3081e27..cb2b7ab 100644
--- a/PLUGINS/src/pictures/Makefile
+++ b/PLUGINS/src/pictures/Makefile
@@ -19,7 +19,7 @@ VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ pri
 PKGCFG = $(if $(VDRDIR),$(shell pkg-config --variable=$(1) $(VDRDIR)/vdr.pc),$(shell pkg-config --variable=$(1) vdr || pkg-config --variable=$(1) ../../../vdr.pc))
 LIBDIR = $(call PKGCFG,libdir)
 LOCDIR = $(call PKGCFG,locdir)
-PLGCFG = $(call PKGCFG,plgcfg)
+PLUGINCONFIG = $(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
 
@@ -34,7 +34,7 @@ APIVERSION = $(call PKGCFG,apiversion)
 
 ### Allow user defined options to overwrite defaults:
 
--include $(PLGCFG)
+-include $(PLUGINCONFIG)
 
 ### The name of the distribution archive:
 
diff --git a/PLUGINS/src/rcu/Makefile b/PLUGINS/src/rcu/Makefile
index 3dbecdd..61ecdc3 100644
--- a/PLUGINS/src/rcu/Makefile
+++ b/PLUGINS/src/rcu/Makefile
@@ -18,7 +18,7 @@ VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ pri
 # Use package data if installed...otherwise assume we're under the VDR source directory:
 PKGCFG = $(if $(VDRDIR),$(shell pkg-config --variable=$(1) $(VDRDIR)/vdr.pc),$(shell pkg-config --variable=$(1) vdr || pkg-config --variable=$(1) ../../../vdr.pc))
 LIBDIR = $(call PKGCFG,libdir)
-PLGCFG = $(call PKGCFG,plgcfg)
+PLUGINCONFIG = $(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
 
@@ -33,7 +33,7 @@ APIVERSION = $(call PKGCFG,apiversion)
 
 ### Allow user defined options to overwrite defaults:
 
--include $(PLGCFG)
+-include $(PLUGINCONFIG)
 
 ### The name of the distribution archive:
 
diff --git a/PLUGINS/src/servicedemo/Makefile b/PLUGINS/src/servicedemo/Makefile
index e5ba5f5..417b890 100644
--- a/PLUGINS/src/servicedemo/Makefile
+++ b/PLUGINS/src/servicedemo/Makefile
@@ -19,7 +19,7 @@ VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN1).c | awk '{ pr
 # Use package data if installed...otherwise assume we're under the VDR source directory:
 PKGCFG = $(if $(VDRDIR),$(shell pkg-config --variable=$(1) $(VDRDIR)/vdr.pc),$(shell pkg-config --variable=$(1) vdr || pkg-config --variable=$(1) ../../../vdr.pc))
 LIBDIR = $(call PKGCFG,libdir)
-PLGCFG = $(call PKGCFG,plgcfg)
+PLUGINCONFIG = $(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
 
@@ -34,7 +34,7 @@ APIVERSION = $(call PKGCFG,apiversion)
 
 ### Allow user defined options to overwrite defaults:
 
--include $(PLGCFG)
+-include $(PLUGINCONFIG)
 
 ### The name of the distribution archive:
 
diff --git a/PLUGINS/src/skincurses/Makefile b/PLUGINS/src/skincurses/Makefile
index fa0ce41..0b83009 100644
--- a/PLUGINS/src/skincurses/Makefile
+++ b/PLUGINS/src/skincurses/Makefile
@@ -19,7 +19,7 @@ VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ pri
 PKGCFG = $(if $(VDRDIR),$(shell pkg-config --variable=$(1) $(VDRDIR)/vdr.pc),$(shell pkg-config --variable=$(1) vdr || pkg-config --variable=$(1) ../../../vdr.pc))
 LIBDIR = $(call PKGCFG,libdir)
 LOCDIR = $(call PKGCFG,locdir)
-PLGCFG = $(call PKGCFG,plgcfg)
+PLUGINCONFIG = $(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
 
@@ -34,7 +34,7 @@ APIVERSION = $(call PKGCFG,apiversion)
 
 ### Allow user defined options to overwrite defaults:
 
--include $(PLGCFG)
+-include $(PLUGINCONFIG)
 
 ### The name of the distribution archive:
 
diff --git a/PLUGINS/src/status/Makefile b/PLUGINS/src/status/Makefile
index 8f6e26f..c84258e 100644
--- a/PLUGINS/src/status/Makefile
+++ b/PLUGINS/src/status/Makefile
@@ -18,7 +18,7 @@ VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ pri
 # Use package data if installed...otherwise assume we're under the VDR source directory:
 PKGCFG = $(if $(VDRDIR),$(shell pkg-config --variable=$(1) $(VDRDIR)/vdr.pc),$(shell pkg-config --variable=$(1) vdr || pkg-config --variable=$(1) ../../../vdr.pc))
 LIBDIR = $(call PKGCFG,libdir)
-PLGCFG = $(call PKGCFG,plgcfg)
+PLUGINCONFIG = $(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
 
@@ -33,7 +33,7 @@ APIVERSION = $(call PKGCFG,apiversion)
 
 ### Allow user defined options to overwrite defaults:
 
--include $(PLGCFG)
+-include $(PLUGINCONFIG)
 
 ### The name of the distribution archive:
 
diff --git a/PLUGINS/src/svdrpdemo/Makefile b/PLUGINS/src/svdrpdemo/Makefile
index 2e39140..532db3f 100644
--- a/PLUGINS/src/svdrpdemo/Makefile
+++ b/PLUGINS/src/svdrpdemo/Makefile
@@ -18,7 +18,7 @@ VERSION = $(shell grep 'static const char \*VERSION *=' $(PLUGIN).c | awk '{ pri
 # Use package data if installed...otherwise assume we're under the VDR source directory:
 PKGCFG = $(if $(VDRDIR),$(shell pkg-config --variable=$(1) $(VDRDIR)/vdr.pc),$(shell pkg-config --variable=$(1) vdr || pkg-config --variable=$(1) ../../../vdr.pc))
 LIBDIR = $(call PKGCFG,libdir)
-PLGCFG = $(call PKGCFG,plgcfg)
+PLUGINCONFIG = $(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
 
@@ -33,7 +33,7 @@ APIVERSION = $(call PKGCFG,apiversion)
 
 ### Allow user defined options to overwrite defaults:
 
--include $(PLGCFG)
+-include $(PLUGINCONFIG)
 
 ### The name of the distribution archive:
 
diff --git a/newplugin b/newplugin
index 12eca5a..e035c0e 100755
--- a/newplugin
+++ b/newplugin
@@ -78,7 +78,7 @@ VERSION = \$(shell grep 'static const char \\*VERSION *=' \$(PLUGIN).c | awk '{
 PKGCFG = \$(if \$(VDRDIR),\$(shell pkg-config --variable=\$(1) \$(VDRDIR)/vdr.pc),\$(shell pkg-config --variable=\$(1) vdr || pkg-config --variable=\$(1) ../../../vdr.pc))
 LIBDIR = \$(call PKGCFG,libdir)
 LOCDIR = \$(call PKGCFG,locdir)
-PLGCFG = \$(call PKGCFG,plgcfg)
+PLUGINCONFIG = \$(call PKGCFG,plgcfg)
 #
 TMPDIR ?= /tmp
 
@@ -93,7 +93,7 @@ APIVERSION = \$(call PKGCFG,apiversion)
 
 ### Allow user defined options to overwrite defaults:
 
--include \$(PLGCFG)
+-include \$(PLUGINCONFIG)
 
 ### The name of the distribution archive:
 
-- 
1.7.11.7